SystemOrganization addCategory: #'SystemEditor-Tests'!
SystemOrganization addCategory: #'SystemEditor-Editors'!
SystemOrganization addCategory: #'SystemEditor-Info'!
SystemOrganization addCategory: #'SystemEditor-Exceptions'!

SharedPool subclass: #EditorSubjectPool
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemEditor-Tests'!

Object subclass: #ClassEditor
	instanceVariableNames: 'subject system superclass name type instVarNames classVarNames sharedPools methods'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemEditor-Editors'!

!ClassEditor class methodsFor: 'instance creation' stamp: 'cwp 11/6/2005 23:17'!
forNewClassNamed: aSymbol
	^ self named: aSymbol for: SystemEditor new! !

!ClassEditor class methodsFor: 'instance creation' stamp: 'cwp 11/6/2005 23:26'!
named: aSymbol for: aSystemEditor
	| subject inst |
	subject _ aSystemEditor edClassAt: aSymbol ifAbsent: [nil].
	inst _ self on: subject for: aSystemEditor.
	subject ifNil: [inst setName: aSymbol].
	^ inst! !

!ClassEditor class methodsFor: 'instance creation' stamp: 'cwp 11/2/2005 22:59'!
on: aClass
	^ self on: aClass for: SystemEditor new! !

!ClassEditor class methodsFor: 'instance creation' stamp: 'cwp 10/30/2005 12:24'!
on: aClass for: aSystemEditor
	| meta instance |
	meta _ MetaclassEditor new.
	instance _ meta new.
	instance setSubject: aClass system: aSystemEditor.
	^ instance! !

!ClassEditor methodsFor: 'editing' stamp: 'cwp 10/24/2005 08:27'!
addClassVarName: aSymbol
	classVarNames ifNil: [classVarNames _ subject classVarNames].
	classVarNames _ classVarNames copyWith: aSymbol asSymbol! !

!ClassEditor methodsFor: 'editing' stamp: 'cwp 11/12/2005 21:38'!
addInstVarName: aString 
	instVarNames ifNil: [instVarNames _ subject instVarNames].
	(instVarNames includes: aString)
		ifFalse: [instVarNames _ instVarNames copyWith: aString]! !

!ClassEditor methodsFor: 'editing' stamp: 'cwp 10/23/2005 16:03'!
addSharedPool: aSharedPool 
	sharedPools ifNil: [sharedPools _ subject sharedPools].
	sharedPools _ sharedPools copyWith: aSharedPool! !

!ClassEditor methodsFor: 'reflecting' stamp: 'cwp 11/4/2005 08:48'!
allInstVarNames
	^ instVarNames
		ifNil: [subject instVarNames]
		ifNotNil: [subject superclass instVarNames, instVarNames]! !

!ClassEditor methodsFor: 'reflecting' stamp: 'cwp 11/4/2005 08:23'!
classPool
	| pool |
	pool _ subject ifNil: [Dictionary new] ifNotNil: [subject classPool copy].
	classVarNames ifNil: [^ pool].
	pool keys do: [:ea | (classVarNames includes: ea) ifFalse: [pool removeKey: ea]].
	classVarNames do: [:ea | (pool includesKey: ea) ifFalse: [pool at: ea put: nil]].
	^ pool! !

!ClassEditor methodsFor: 'reflecting' stamp: 'cwp 10/23/2005 15:41'!
classVarNames
	^ classVarNames ifNil: [subject classVarNames]! !

!ClassEditor methodsFor: 'reflecting' stamp: 'cwp 11/4/2005 08:49'!
compilerClass
	^ subject 
		ifNil: [Compiler]
		ifNotNil: [subject compilerClass]! !

!ClassEditor methodsFor: 'editing' stamp: 'cwp 10/30/2005 10:01'!
compile: source classified: category
	^ self 
		compile: source
		classified: category
		withStamp: Utilities changeStamp
		notifying: nil
		logSource: self subject acceptsLoggingOfCompilation ! !

!ClassEditor methodsFor: 'editing' stamp: 'cwp 10/29/2005 23:10'!
compile: source classified: category notifying: anObject
	^ self 
		compile: source
		classified: category
		withStamp: Utilities changeStamp
		notifying: anObject
		logSource: self subject acceptsLoggingOfCompilation ! !

!ClassEditor methodsFor: 'editing' stamp: 'cwp 10/29/2005 23:04'!
compile: source classified: category withStamp: aString notifying: anObject
	^ self 
		compile: source
		classified: category
		withStamp: aString
		notifying: anObject
		logSource: self subject acceptsLoggingOfCompilation ! !

!ClassEditor methodsFor: 'editing' stamp: 'cwp 10/25/2005 22:50'!
compile: source classified: category withStamp: aString notifying: anObject logSource: aBoolean
	| cm |
	cm := ModifiedMethod
			source: source
			classified: category
			stamp: aString
			notifying: anObject
			logging: aBoolean.
	methods ifNil: [methods _ MethodDictionaryEditor on: self subject methodDictionary].
	methods add: cm.! !

!ClassEditor methodsFor: 'building' stamp: 'cwp 11/6/2005 00:49'!
edBuild
	| meta result |
	self edRequiresBuild ifFalse: [^ subject].
	meta _ self class edBuild.
	result _ subject
		ifNil: [meta new]
		ifNotNil: [meta adoptInstance: subject from: subject class].
	result
		superclass: self superclass;
		setFormat: self format;
		setName: self name;
		setInstVarNames: self instVarNames;
		classPoolFrom: self;
		instVarNamed: #sharedPools put: self sharedPools;
		methodDictionary: self methodDictionary.

	^ result! !

!ClassEditor methodsFor: 'building' stamp: 'cwp 10/29/2005 10:20'!
edClassFormat
	| superFormat |
	superFormat _ ClassFormat fromBits: self superclass format.
	^ self typeOfClass = #normal
		ifTrue: [superFormat namedSubclass: self instVarNames size]
		ifFalse: [superFormat indexedSubclass: self instVarNames size]! !

!ClassEditor methodsFor: 'building' stamp: 'cwp 10/29/2005 12:44'!
edIsValid
	^ self isPointers 
		ifTrue: [self instVarNames size < 255]
		ifFalse: [self instVarNames isEmpty]! !

!ClassEditor methodsFor: 'building' stamp: 'cwp 11/3/2005 07:56'!
edName: aSymbol superclass: aClass type: typeOfClass instVarString: instString classVarString: classString poolImports: poolString category: catString 
	| scanner |
	scanner _ Scanner new.
	name _ aSymbol.
	superclass _ aClass.
	type _ typeOfClass.
	instVarNames _ scanner scanFieldNames: instString.
	classVarNames _ scanner scanFieldNames: classString.
	sharedPools _ (scanner scanFieldNames: poolString)
					collect: [:ea | system edResolve: ea].
	! !

!ClassEditor methodsFor: 'building' stamp: 'cwp 11/5/2005 12:26'!
edRequiresBuild
	^ self class edRequiresBuild 
		or: [self edRequiresRecompile]
		or: [superclass ~~ nil]
		or: [methods ~~ nil]
! !

!ClassEditor methodsFor: 'building' stamp: 'cwp 11/7/2005 19:54'!
edRequiresMigration
	^ subject
		ifNotNil: [self format ~= subject format]
		ifNil: [false]! !

!ClassEditor methodsFor: 'building' stamp: 'cwp 10/30/2005 16:28'!
edRequiresRecompile
	^ instVarNames ~~ nil
		| classVarNames ~~ nil
		| sharedPools ~~ nil
! !

!ClassEditor methodsFor: 'building' stamp: 'cwp 11/7/2005 20:00'!
edRequiresSubclassRebuild
	^ self class edRequiresSubclassRebuild 
		or: [self edRequiresMigration]
		or: [self edRequiresRecompile]! !

!ClassEditor methodsFor: 'reflecting' stamp: 'cwp 10/29/2005 10:19'!
format
	^ self edClassFormat bits! !

!ClassEditor methodsFor: 'reflecting' stamp: 'cwp 10/25/2005 22:35'!
includesSelector: aSelector
	^ (methods ifNil: [self subject] ifNotNil: [methods])
		includesSelector: aSelector! !

!ClassEditor methodsFor: 'reflecting' stamp: 'cwp 11/12/2005 20:57'!
instSize
	^ self superclass instSize + self instVarNames size.! !

!ClassEditor methodsFor: 'reflecting' stamp: 'cwp 10/23/2005 15:37'!
instVarNames
	^ instVarNames ifNil: [subject instVarNames]! !

!ClassEditor methodsFor: 'reflecting' stamp: 'cwp 10/29/2005 10:23'!
isBits
	^ #(bytes words) includes: self typeOfClass! !

!ClassEditor methodsFor: 'reflecting' stamp: 'cwp 10/29/2005 10:22'!
isBytes
	^ self typeOfClass = #bytes! !

!ClassEditor methodsFor: 'reflecting' stamp: 'cwp 10/29/2005 10:24'!
isPointers
	^ #(normal weak variable) includes: self typeOfClass! !

!ClassEditor methodsFor: 'reflecting' stamp: 'cwp 10/29/2005 10:26'!
isVariable
	^ (self typeOfClass = #normal) not! !

!ClassEditor methodsFor: 'reflecting' stamp: 'cwp 10/29/2005 10:34'!
isWeak
	^ self typeOfClass = #weak! !

!ClassEditor methodsFor: 'reflecting' stamp: 'cwp 10/29/2005 10:33'!
isWords
	^ #(words weak variable) includes: self typeOfClass ! !

!ClassEditor methodsFor: 'compiling' stamp: 'cwp 10/27/2005 08:00'!
literalScannedAs: literal notifying: anEncoder 
	literal isVariableBinding ifTrue: [self halt].
	^ literal! !

!ClassEditor methodsFor: 'building' stamp: 'cwp 10/30/2005 18:22'!
methodDictionary
	| methodEditor |
	(methods isNil and: [self edRequiresRecompile not]) ifTrue: [^ subject methodDictionary].
	methodEditor _ methods ifNil: [MethodDictionaryEditor on: self subject methodDictionary].
	^ methodEditor buildFor: self! !

!ClassEditor methodsFor: 'reflecting' stamp: 'cwp 11/3/2005 07:44'!
name
	^ name ifNil: [subject name]! !

!ClassEditor methodsFor: 'printing' stamp: 'cwp 10/23/2005 02:58'!
printOn: aStream
	aStream 
		nextPutAll: 'a ClassEditor on: ';
		nextPutAll: subject name! !

!ClassEditor methodsFor: 'editing' stamp: 'cwp 10/23/2005 15:58'!
removeClassVarName: aString 
	classVarNames ifNil: [classVarNames _ subject classVarNames].
	classVarNames _ classVarNames copyWithout: aString! !

!ClassEditor methodsFor: 'editing' stamp: 'cwp 10/23/2005 15:39'!
removeInstVarName: aString 
	instVarNames ifNil: [instVarNames _ subject instVarNames].
	instVarNames _ instVarNames copyWithout: aString! !

!ClassEditor methodsFor: 'editing' stamp: 'cwp 10/25/2005 23:03'!
removeSelector: aSymbol 
	methods ifNil: [methods _ MethodDictionaryEditor on: self subject methodDictionary].
	methods remove: aSymbol.! !

!ClassEditor methodsFor: 'editing' stamp: 'cwp 10/23/2005 16:06'!
removeSharedPool: aSharedPool 
	sharedPools ifNil: [sharedPools _ subject sharedPools].
	sharedPools _ sharedPools copyWithout: aSharedPool! !

!ClassEditor methodsFor: 'editing' stamp: 'cwp 11/4/2005 08:14'!
setName: aSymbol
	name _ aSymbol! !

!ClassEditor methodsFor: 'initialize-release' stamp: 'cwp 10/23/2005 15:36'!
setSubject: aClass
	subject _ aClass.
	! !

!ClassEditor methodsFor: 'initialize-release' stamp: 'cwp 11/5/2005 14:48'!
setSubject: aClass system: aSystemEditor
	subject _ aClass.
	system _ aSystemEditor.
	subject ifNil:
		[superclass _ Object.
		name _ #Annonymous.
		type _ #normal.
		instVarNames _ ''.
		classVarNames _ ''.
		sharedPools _ Array new.
		methods _ MethodDictionaryEditor on: MethodDictionary new.
		self class edInitializeForNewClass]
	! !

!ClassEditor methodsFor: 'reflecting' stamp: 'cwp 10/24/2005 18:57'!
sharedPools
	^ sharedPools ifNil: [subject sharedPools]! !

!ClassEditor methodsFor: 'editing' stamp: 'cwp 11/3/2005 07:36'!
subclass: aSymbol instanceVariableNames: instString classVariableNames: classString poolDictionaries: poolString category: categoryString 
	^ system 
		at: aSymbol
		ifAbsent: [(ClassEditor on: nil for: system)
					edName: aSymbol
					superclass: (subject ifNil: [Object])
					type: #normal
					instVarString: instString
					classVarString: classString
					poolImports: poolString
					category: categoryString]! !

!ClassEditor methodsFor: 'accessing' stamp: 'cwp 10/23/2005 01:54'!
subject
	^ subject! !

!ClassEditor methodsFor: 'reflecting' stamp: 'cwp 10/24/2005 07:54'!
superclass
	^ superclass ifNil: [self subject superclass]! !

!ClassEditor methodsFor: 'editing' stamp: 'cwp 10/24/2005 07:54'!
superclass: aClass
	superclass _ aClass! !

!ClassEditor methodsFor: 'accessing' stamp: 'cwp 10/30/2005 12:33'!
system
	^ system! !

!ClassEditor methodsFor: 'reflecting' stamp: 'cwp 10/28/2005 22:14'!
typeOfClass
	^ type ifNil: [type _ subject typeOfClass]! !

!ClassEditor methodsFor: 'editing' stamp: 'cwp 10/29/2005 10:28'!
typeOfClass: aSymbol
	type _ aSymbol! !

!ClassEditor methodsFor: 'building' stamp: 'cwp 11/19/2005 12:46'!
validate
	(self instSize >= 255) ifTrue: [InvalidClassFormat signal].
	(self isBits and: [self instSize >= 1]) ifTrue: [InvalidClassFormat signal].! !

Object subclass: #ClassExporter
	instanceVariableNames: 'environment classes oldClasses newClasses'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemEditor-Editors'!

!ClassExporter class methodsFor: 'instance creation' stamp: 'cwp 11/5/2005 17:11'!
on: anEnvironment
	^ self new setEnvironment: anEnvironment! !

!ClassExporter methodsFor: 'public' stamp: 'cwp 11/5/2005 17:11'!
addClass: aClass
	classes add: aClass! !

!ClassExporter methodsFor: 'public' stamp: 'cwp 11/5/2005 18:46'!
commit
	[classes do: [:ea | self export: ea].
	self forwardIdentities]
		valueUnpreemptively
! !

!ClassExporter methodsFor: 'public' stamp: 'cwp 11/5/2005 18:43'!
environment
	^ environment! !

!ClassExporter methodsFor: 'private' stamp: 'cwp 11/5/2005 18:18'!
export: aClass 
	aClass superclass addSubclass: aClass.
	(environment includesKey: aClass name)
		ifTrue: [self replace: aClass]
		ifFalse: [environment at: aClass name put: aClass]! !

!ClassExporter methodsFor: 'private' stamp: 'cwp 11/7/2005 20:25'!
forwardIdentities
	oldClasses _ oldClasses asArray.
	newClasses _ newClasses asArray.
	oldClasses  elementsForwardIdentityTo: newClasses.
	oldClasses _ nil.
	newClasses _ nil.! !

!ClassExporter methodsFor: 'private' stamp: 'cwp 11/7/2005 20:27'!
replace: aClass
	oldClasses add: (environment at: aClass name).
	newClasses add: aClass! !

!ClassExporter methodsFor: 'initialize-release' stamp: 'cwp 11/5/2005 18:36'!
setEnvironment: anEnvironment 
	environment := anEnvironment.
	classes := OrderedCollection new.
	oldClasses _ OrderedCollection new.
	newClasses _ OrderedCollection new.! !

Object subclass: #ClassFormat
	instanceVariableNames: 'instSize instSpec cClassIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemEditor-Editors'!

!ClassFormat commentStamp: 'cwp 9/25/2004 16:07' prior: 0!
I am an expert on the way the Squeak VM encodes class formats. My instance variable, 'bits', is identical in format to the 'format' instance variable of Behavior. I have methods for interpreting those bits. The class format integer is 18 bits in length. The instSize field is split into two parts for backwards compatibility.

<2 bits=instSize//64> <5 bits=cClass> <4 bits=instSpec> <6 bits=instSize\\64> <1 bit=0>

- instSize: the number of named instance variables
- cClass: the index into the compact class table
- instSpec: values indicating how instances are organized
	0 - no state
	1 - named instance variables only
	2 - variable number of object pointers
	3 - named instance variables, variable number of object pointers
	4 - variable number of weak object pointers
	6 - variable number of words
	8 - variable number of bytes!

!ClassFormat class methodsFor: 'instance creation' stamp: 'cwp 9/26/2004 18:14'!
bytes
	^ self size: 0 spec: self bytesSpec index: 0! !

!ClassFormat class methodsFor: 'storage specifications' stamp: 'cwp 9/26/2004 17:52'!
bytesSpec
	^ 8! !

!ClassFormat class methodsFor: 'instance creation' stamp: 'cwp 9/26/2004 17:41'!
fromBits: bits
	^ self
		size: (((bits bitShift: -10) bitAnd: 192) + ((bits bitShift: -1) bitAnd: 63) - 1)
		spec: ((bits bitShift: -7) bitAnd: 15)
		index: ((bits bitShift: -11) bitAnd: 31)! !

!ClassFormat class methodsFor: 'instance creation' stamp: 'cwp 9/26/2004 18:12'!
indexed
	^ self indexed: 0! !

!ClassFormat class methodsFor: 'storage specifications' stamp: 'cwp 9/26/2004 17:57'!
indexedSpec
	^ 2! !

!ClassFormat class methodsFor: 'storage specifications' stamp: 'cwp 9/26/2004 18:08'!
indexedSpec: size
	^ size = 0 ifTrue: [self indexedSpec] ifFalse: [self namedAndIndexedSpec]! !

!ClassFormat class methodsFor: 'instance creation' stamp: 'cwp 9/26/2004 18:03'!
indexed: size
	^ self 
		size: size
		spec: (self indexedSpec: size)
		index: 0! !

!ClassFormat class methodsFor: 'instance creation' stamp: 'cwp 9/26/2004 17:59'!
named
	^ self named: 0! !

!ClassFormat class methodsFor: 'storage specifications' stamp: 'cwp 9/26/2004 17:57'!
namedAndIndexedSpec
	^ 3! !

!ClassFormat class methodsFor: 'storage specifications' stamp: 'cwp 9/26/2004 17:55'!
namedSpec
	^ 1! !

!ClassFormat class methodsFor: 'instance creation' stamp: 'cwp 9/26/2004 18:06'!
named: size
	^ self
		size: size
		spec: self namedSpec
		index: 0! !

!ClassFormat class methodsFor: 'instance creation' stamp: 'cwp 9/26/2004 18:16'!
noState
	^ self size: 0 spec: self noStateSpec index: 0! !

!ClassFormat class methodsFor: 'storage specifications' stamp: 'cwp 9/26/2004 17:55'!
noStateSpec
	^ 0! !

!ClassFormat class methodsFor: 'instance creation' stamp: 'cwp 9/26/2004 17:41'!
size: instSize spec: instSpec index: cClassIndex
	^ self new setSize: instSize spec: instSpec index: cClassIndex! !

!ClassFormat class methodsFor: 'instance creation' stamp: 'cwp 9/26/2004 18:18'!
weak
	^ self size: 0 spec: self weakSpec index: 0! !

!ClassFormat class methodsFor: 'storage specifications' stamp: 'cwp 9/26/2004 17:52'!
weakSpec
	^ 4! !

!ClassFormat class methodsFor: 'instance creation' stamp: 'cwp 9/26/2004 18:17'!
words
	^ self size: 0 spec: self wordsSpec index: 0! !

!ClassFormat class methodsFor: 'storage specifications' stamp: 'cwp 9/26/2004 17:52'!
wordsSpec
	^ 6! !

!ClassFormat methodsFor: 'accessing' stamp: 'cwp 9/26/2004 17:37'!
bits
	"Based on ClassBuilder>>format:variable:words:pointers:weak - ar 7/11/1999 06:39 "

	| bits |
	bits _ (instSize+1) // 64. 	
	bits _ (bits bitShift: 5) + cClassIndex.
	bits _ (bits bitShift: 4) + instSpec.
	bits _ (bits bitShift: 6) + ((instSize+1)\\64).  "+1 since prim instSize field includes header"
	bits _ (bits bitShift: 1). "This shift plus integer bit lets wordSize work like byteSize"
	^ bits! !

!ClassFormat methodsFor: 'accessing' stamp: 'cwp 9/26/2004 17:36'!
cClassIndex
	^ cClassIndex! !

!ClassFormat methodsFor: 'converting' stamp: 'cwp 9/26/2004 18:15'!
indexedSubclass: nInstVars
	| newSize |
	self isPointers ifFalse: [self error: 'Can''t make a pointer subclass.'].
	newSize _ self instSize + nInstVars.
	newSize > 254 ifTrue: [self error: 'Too many instance variables'].
	
	^ self class indexed: newSize! !

!ClassFormat methodsFor: 'accessing' stamp: 'cwp 9/26/2004 17:37'!
instSize
	^ instSize! !

!ClassFormat methodsFor: 'accessing' stamp: 'cwp 9/26/2004 17:37'!
instSpec
	^ instSpec! !

!ClassFormat methodsFor: 'testing' stamp: 'cwp 9/25/2004 13:47'!
isBits
	"Answer whether the receiver contains just bits (not pointers)."

	^ self instSpec >= 6! !

!ClassFormat methodsFor: 'testing' stamp: 'cwp 9/25/2004 13:48'!
isBytes
	"Answer whether the receiver has 8-bit instance variables."

	^ self instSpec >= 8! !

!ClassFormat methodsFor: 'testing' stamp: 'cwp 9/25/2004 13:48'!
isFixed
	"Answer whether the receiver does not have a variable (indexable) part."

	^self isVariable not! !

!ClassFormat methodsFor: 'testing' stamp: 'cwp 9/25/2004 13:48'!
isPointers
	"Answer whether the receiver contains just pointers (not bits)."

	^self isBits not! !

!ClassFormat methodsFor: 'testing' stamp: 'cwp 9/25/2004 13:48'!
isVariable
	"Answer whether the receiver has indexable variables."

	^ self instSpec >= 2! !

!ClassFormat methodsFor: 'testing' stamp: 'cwp 9/25/2004 13:48'!
isWeak
	"Answer whether the receiver has contains weak references."
	^ self instSpec = 4! !

!ClassFormat methodsFor: 'testing' stamp: 'cwp 9/25/2004 13:49'!
isWords
	"Answer whether the receiver has 32-bit instance variables."

	^ self isBytes not! !

!ClassFormat methodsFor: 'converting' stamp: 'cwp 9/26/2004 18:09'!
namedSubclass: nInstVars 
	| newSize |
	newSize := self instSize + nInstVars.
	newSize > 254 ifTrue: [self error: 'Too many instance variables'].
	^self class named: newSize! !

!ClassFormat methodsFor: 'initializing' stamp: 'cwp 9/26/2004 17:39'!
setSize: size spec: spec index: index
	instSize _ size.
	instSpec _ spec.
	cClassIndex _ index.! !

!ClassFormat methodsFor: 'converting' stamp: 'cwp 9/26/2004 18:28'!
withInstSize: aSmallInteger
	self isPointers ifFalse: [self error: 'Only pointer formats can have named variables'].
	^ self class size: aSmallInteger spec: self instSpec index: self cClassIndex! !

Object subclass: #EditorSubject
	instanceVariableNames: 'alpha beta'
	classVariableNames: 'Aleph Beth'
	poolDictionaries: 'EditorSubjectPool'
	category: 'SystemEditor-Tests'!

EditorSubject class
	instanceVariableNames: 'omega'!

!EditorSubject class methodsFor: 'as yet unclassified' stamp: 'cwp 10/24/2005 18:38'!
aleph
	^ Aleph ! !

!EditorSubject class methodsFor: 'as yet unclassified' stamp: 'cwp 10/24/2005 18:38'!
aleph: anObject
	Aleph _ anObject! !

!EditorSubject class methodsFor: 'as yet unclassified' stamp: 'cwp 10/28/2005 08:18'!
ayin
	^ 22! !

!EditorSubject methodsFor: 'as yet unclassified' stamp: 'cwp 10/26/2005 08:41'!
het
	^ 'first letter of the phoenician alphabet'! !

Object subclass: #InstanceMigrator
	instanceVariableNames: 'map instSize origin destination'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemEditor-Editors'!

!InstanceMigrator class methodsFor: 'as yet unclassified' stamp: 'cwp 11/2/2005 08:24'!
from: oldClass to: newClass
	^ self new setOrigin: oldClass destination: newClass! !

!InstanceMigrator class methodsFor: 'as yet unclassified' stamp: 'cwp 10/30/2005 22:55'!
instVarMappingFrom: old to: new
	| oldInstVarNames |
	oldInstVarNames _ old allInstVarNames.
	^ new allInstVarNames 
			collect: [:instVarName | oldInstVarNames indexOf: instVarName].
! !

!InstanceMigrator methodsFor: 'migrating' stamp: 'cwp 11/2/2005 08:31'!
createFrom: oldInstance
	| newInstance |
	destination isVariable
		ifTrue: [newInstance := destination basicNew: oldInstance basicSize]
		ifFalse: [newInstance := destination basicNew].
	^ newInstance! !

!InstanceMigrator methodsFor: 'initialize-release' stamp: 'cwp 11/2/2005 08:38'!
createMap
	| oldInstVarNames |
	oldInstVarNames _ origin allInstVarNames.
	^ destination allInstVarNames 
			collect: [:instVarName | oldInstVarNames indexOf: instVarName].
! !

!InstanceMigrator methodsFor: 'accessing' stamp: 'cwp 11/2/2005 08:50'!
instances
	^ origin allInstances asArray! !

!InstanceMigrator methodsFor: 'migrating' stamp: 'cwp 11/2/2005 08:31'!
migrate: oldInstance
	| newInstance |
	newInstance _ self createFrom: oldInstance.
	1 to: instSize do: 
		[:offset | 
		(map at: offset) > 0 ifTrue: 
			[newInstance 
				instVarAt: offset
				put: (oldInstance instVarAt: (map at: offset))]].
	destination isVariable ifTrue: 
		[1 to: oldInstance basicSize do: 
			[:offset | newInstance basicAt: offset put: (oldInstance basicAt: offset)]].
	^newInstance! !

!InstanceMigrator methodsFor: 'initialize-release' stamp: 'cwp 11/2/2005 08:25'!
setOrigin: oldClass destination: newClass
	origin _ oldClass.
	destination _ newClass.
	map _ self createMap.
	instSize _ destination instSize! !

Object subclass: #MethodDictionaryEditor
	instanceVariableNames: 'subject additions removals'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemEditor-Editors'!

!MethodDictionaryEditor class methodsFor: 'instance creation' stamp: 'cwp 11/3/2005 07:30'!
empty
	^ self on: MethodDictionary new! !

!MethodDictionaryEditor class methodsFor: 'instance creation' stamp: 'cwp 10/25/2005 22:48'!
on: aMethodDictionary 
	^ self new setSubject: aMethodDictionary! !

!MethodDictionaryEditor methodsFor: 'editing' stamp: 'cwp 10/25/2005 22:51'!
add: aModifiedMethod 
	additions at: aModifiedMethod selector put: aModifiedMethod! !

!MethodDictionaryEditor methodsFor: 'building' stamp: 'cwp 11/9/2005 22:24'!
buildFor: classEditor
	| result |
	result _ MethodDictionary new.
	subject keysAndValuesDo:
		[:selector :cm |
		(self selectorIsModified: selector)
			ifFalse: [result at: selector put: (self recompile: selector from: cm for: classEditor)]].
	additions keysAndValuesDo: 
		[:selector :cm | 
		result at: selector put: (cm compileFor: classEditor)].
	^ result
! !

!MethodDictionaryEditor methodsFor: 'testing' stamp: 'cwp 10/28/2005 08:15'!
includesSelector: aSymbol 
	(additions includesKey: aSymbol) ifTrue: [^ true].
	(removals includes: aSymbol) ifTrue: [^false].
	(subject includesKey: aSymbol) ifTrue: [^ true].
	^ false! !

!MethodDictionaryEditor methodsFor: 'building' stamp: 'cwp 11/9/2005 22:24'!
recompile: aSelector from: aCompiledMethod for: aClassEditor
	| trailer node |
	aClassEditor edRequiresRecompile ifFalse: [^ aCompiledMethod].
	trailer _ aCompiledMethod trailer.
	node _ aClassEditor compilerClass new
			compile: (aCompiledMethod 
						getSourceFor: aSelector 
						in: aClassEditor)
			in: aClassEditor
			notifying: nil
			ifFail: [self error: 'Compilation failed'].
	node selector == aSelector ifFalse: [self error: 'selector changed!!'].
	^ node generate: trailer! !

!MethodDictionaryEditor methodsFor: 'editing' stamp: 'cwp 10/25/2005 23:08'!
remove: aSymbol 
	additions removeKey: aSymbol ifAbsent: [].
	removals add: aSymbol! !

!MethodDictionaryEditor methodsFor: 'testing' stamp: 'cwp 10/26/2005 08:44'!
selectorIsModified: aSelector
	^ (additions includesKey: aSelector) or: [removals includes: aSelector]! !

!MethodDictionaryEditor methodsFor: 'initialization' stamp: 'cwp 10/25/2005 23:04'!
setSubject: aMethodDictionary
	subject _ aMethodDictionary.
	additions _ IdentityDictionary new.
	removals _ IdentitySet new.! !

Object subclass: #MigrationTransaction
	instanceVariableNames: 'migrators oldInstances newInstances'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemEditor-Editors'!

!MigrationTransaction methodsFor: 'private' stamp: 'cwp 11/2/2005 08:47'!
addInstances: batch 
	| tmp |
	oldInstances := oldInstances , batch.
	tmp := newInstances.
	newInstances := Array new: tmp size + batch size.
	newInstances 
		replaceFrom: 1
		to: tmp size
		with: tmp
		startingAt: 1! !

!MigrationTransaction methodsFor: 'public' stamp: 'cwp 11/2/2005 08:36'!
addMigrator: aMigrator
	migrators add: aMigrator! !

!MigrationTransaction methodsFor: 'public' stamp: 'cwp 11/2/2005 19:44'!
commit
	"The mass become: is a primitive, but we execute this method with preemption
	disabled because we don't want another process creating new instances while
	we're busy converting the existing instances."

	[
		migrators do: [:ea | self migrateUsing: ea].
		oldInstances elementsExchangeIdentityWith: newInstances
	] valueUnpreemptively.! !

!MigrationTransaction methodsFor: 'initialize-release' stamp: 'cwp 11/2/2005 08:38'!
initialize
	migrators _ OrderedCollection new.
	oldInstances _ Array new.
	newInstances _ Array new.! !

!MigrationTransaction methodsFor: 'private' stamp: 'cwp 11/2/2005 08:49'!
migrateUsing: aMigrator 
	| batch offset |
	batch := aMigrator instances.
	batch isEmpty ifTrue: [^self].	"no instances to convert"
	self addInstances: batch.
	offset := oldInstances size - batch size.
	batch withIndexDo: 
		[:inst :i | 
		newInstances at: offset + i put: (aMigrator migrate: inst)]! !

Object subclass: #ModifiedMethod
	instanceVariableNames: 'source category stamp requestor log'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemEditor-Editors'!

!ModifiedMethod class methodsFor: 'as yet unclassified' stamp: 'cwp 10/25/2005 21:36'!
source: source classified: catString stamp: stamp notifying: requestor logging: aBoolean
	^ self new
		setSource: source
		classified: catString
		stamp: stamp
		notifying: requestor
		log: aBoolean! !

!ModifiedMethod methodsFor: 'building' stamp: 'cwp 10/27/2005 08:04'!
compileFor: aClassEditor
	| node |
	node _ aClassEditor subject compilerClass new
				compile: source
				in: aClassEditor
				notifying: requestor
				ifFail: nil.
	node encoder requestor: requestor.
	^ (CompiledMethodWithNode generateMethodFromNode: node trailer: #(0 0 0 0))
		method! !

!ModifiedMethod methodsFor: 'as yet unclassified' stamp: 'cwp 10/25/2005 22:50'!
selector
	^ Parser new parseSelector: source! !

!ModifiedMethod methodsFor: 'as yet unclassified' stamp: 'cwp 10/25/2005 22:47'!
setSource: sourceString classified: catString stamp: timestamp notifying: anObject log: aBoolean
	source _ sourceString.
	category _ catString.
	stamp _ timestamp.
	requestor _ anObject.
	log _ aBoolean ! !

Object subclass: #SystemEditor
	instanceVariableNames: 'subject editors classes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemEditor-Editors'!

!SystemEditor class methodsFor: 'as yet unclassified' stamp: 'cwp 10/28/2005 08:51'!
new
	^ self on: Smalltalk! !

!SystemEditor class methodsFor: 'as yet unclassified' stamp: 'cwp 10/28/2005 08:51'!
on: anEnvironment
	^ self basicNew setSubject: anEnvironment! !

!SystemEditor methodsFor: 'reflecting' stamp: 'cwp 11/6/2005 23:20'!
at: aSymbol 
	^ editors 
		at: aSymbol
		ifAbsentPut: [ClassEditor named: aSymbol for: self]! !

!SystemEditor methodsFor: 'reflecting' stamp: 'cwp 11/5/2005 18:09'!
at: aSymbol ifAbsent: aBlock
	^ editors at: aSymbol ifAbsent: aBlock! !

!SystemEditor methodsFor: 'building' stamp: 'cwp 11/10/2005 21:08'!
commit
	| migration export |
	self validate.

	self edBuildClasses.
	migration := self edPrepareMigration.
	export := self edPrepareExport.
	
	[migration commit.
	export commit] valueUnpreemptively.
	
	^ true! !

!SystemEditor methodsFor: 'building' stamp: 'cwp 11/7/2005 19:46'!
edBuildClasses
	| subeditor |
	editors do: 
		[:editor | 
		classes at: editor name put: editor edBuild.
		editor edRequiresSubclassRebuild ifTrue: 
			[editor subject subclasses do: 
				[:subclass |
				subeditor _ ClassEditor on: subclass for: self.
				classes at: subeditor name put: subeditor edBuild]]]! !

!SystemEditor methodsFor: 'building' stamp: 'cwp 11/6/2005 23:24'!
edClassAt: aSymbol ifAbsent: aBlock
	^ subject at: aSymbol ifAbsent: aBlock! !

!SystemEditor methodsFor: 'building' stamp: 'cwp 11/9/2005 20:46'!
edPrepareExport
	| exporter |
	exporter _ ClassExporter on: subject.
	classes do: [:ea | exporter addClass: ea].
	^ exporter
		! !

!SystemEditor methodsFor: 'building' stamp: 'cwp 11/9/2005 20:46'!
edPrepareMigration
	| txn class |
	txn _ MigrationTransaction new.
	(editors reject: [:ea | ea subject isNil]) do:
		[:editor |
		class _ classes at: editor name.
		txn addMigrator: (InstanceMigrator from: editor subject to: class)].
	^ txn! !

!SystemEditor methodsFor: 'building' stamp: 'cwp 11/3/2005 07:53'!
edResolve: aSymbol
	^ subject at: aSymbol! !

!SystemEditor methodsFor: 'initialize-release' stamp: 'cwp 11/6/2005 23:33'!
setSubject: anEnvironment 
	subject := anEnvironment.
	editors := IdentityDictionary new.
	classes := IdentityDictionary new.! !

!SystemEditor methodsFor: 'accessing' stamp: 'cwp 10/28/2005 08:49'!
subject
	^ subject! !

!SystemEditor methodsFor: 'building' stamp: 'cwp 11/10/2005 21:08'!
validate
	editors do: [:ea | ea validate]! !

Notification subclass: #InvalidClassFormat
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemEditor-Exceptions'!

PackageInfo subclass: #SystemEditorInfo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemEditor-Info'!

!SystemEditorInfo class methodsFor: 'as yet unclassified' stamp: 'cwp 11/5/2005 17:02'!
testClasses
	^ self new classes select: [:ea | ea allSuperclasses includes: TestCase]! !

!SystemEditorInfo class methodsFor: 'as yet unclassified' stamp: 'cwp 11/5/2005 17:01'!
testSuite
	| suite |
	suite _ TestSuite new.
	suite name: self name asString.
	self testClasses do: 
		[:each | 
		each isAbstract ifFalse: [each addToSuiteFromSelectors: suite]].
	^ suite! !

Behavior subclass: #MetaclassEditor
	instanceVariableNames: 'editor subjectSuperclass instVarNames methods'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemEditor-Editors'!

!MetaclassEditor class methodsFor: 'instance creation' stamp: 'cwp 10/23/2005 14:38'!
new
	| instance |
	instance _ self basicNew.
	instance
		superclass: ClassEditor
		methodDictionary: MethodDictionary new
		format: ClassEditor format.
	^ instance! !

!MetaclassEditor methodsFor: 'editing' stamp: 'cwp 11/4/2005 22:08'!
addInstVarName: aString 
	instVarNames ifNil: [instVarNames _ self subject instVarNames].
	instVarNames _ instVarNames copyWith: aString! !

!MetaclassEditor methodsFor: 'reflecting' stamp: 'cwp 10/24/2005 18:21'!
classPool
	^ editor classPool! !

!MetaclassEditor methodsFor: 'editing' stamp: 'cwp 10/28/2005 08:10'!
compile: source classified: category withStamp: aString notifying: anObject logSource: aBoolean
	| cm |
	cm := ModifiedMethod
			source: source
			classified: category
			stamp: aString
			notifying: anObject
			logging: aBoolean.
	methods ifNil: [methods _ MethodDictionaryEditor on: self subject methodDictionary].
	methods add: cm.! !

!MetaclassEditor methodsFor: 'building' stamp: 'cwp 11/10/2005 08:18'!
edBuild
	| result class |
	class _ self subject ifNil: [Metaclass] ifNotNilDo: [:subject | subject class].
	result _ class basicNew.
	result
		superclass: self superclass
		methodDictionary: self methodDictionary
		format: self format.		
	result setInstVarNames: self instVarNames.
	^ result! !

!MetaclassEditor methodsFor: 'building' stamp: 'cwp 11/5/2005 14:48'!
edInitializeForNewClass
	subjectSuperclass _ Object class.
	instVarNames _ Array new.
	methods _ MethodDictionaryEditor on: MethodDictionary new! !

!MetaclassEditor methodsFor: 'building' stamp: 'cwp 11/4/2005 22:01'!
edRequiresBuild
	^ subjectSuperclass ~~ nil
		| instVarNames ~~ nil
		| methods ~~ nil! !

!MetaclassEditor methodsFor: 'building' stamp: 'cwp 11/5/2005 11:43'!
edRequiresRecompile
	^ instVarNames ~~ nil! !

!MetaclassEditor methodsFor: 'building' stamp: 'cwp 11/7/2005 19:51'!
edRequiresSubclassRebuild
	^ self subject
		ifNotNilDo: [:subject | subject format ~= self format]
		ifNil: [false]! !

!MetaclassEditor methodsFor: 'reflecting' stamp: 'cwp 11/4/2005 21:49'!
format
	"Override the implemenation in Behavior. That will return the format of ClassEditor,
	but we want the format of the subject's meta class"

	| superFormat |
	superFormat := ClassFormat fromBits: self superclass format.
	^ (superFormat namedSubclass: self instVarNames size) bits! !

!MetaclassEditor methodsFor: 'reflecting' stamp: 'cwp 10/28/2005 08:11'!
includesSelector: aSelector
	^ (methods ifNil: [self subject] ifNotNil: [methods])
		includesSelector: aSelector! !

!MetaclassEditor methodsFor: 'reflecting' stamp: 'cwp 11/4/2005 08:47'!
instVarNames
	"Override the implemenation in Behavior. That will return the inst vars of 
	ClassEditor, but we want the inst vars of the subject's class."

	^ instVarNames ifNil: [self subject instVarNames]! !

!MetaclassEditor methodsFor: 'metaclass' stamp: 'cwp 11/4/2005 08:45'!
lookupSelector: aSelector
	
	"Override the implementation in Behavior to make ClassEditor
	debuggable. The debugger calls this during simulated execution,
	and since we override #includesSelector and #superclass to 
	reflect on the subject, we get incorrect method dispatch."

	| lookupClass dict |
	lookupClass _ self.
	[lookupClass == nil] whileFalse: 
		[dict _ lookupClass instVarAt: 2.
		(dict includesKey: aSelector)
			ifTrue: [^ dict at: aSelector].
		lookupClass _ lookupClass instVarAt: 1].
	^ nil! !

!MetaclassEditor methodsFor: 'reflecting' stamp: 'cwp 11/4/2005 22:16'!
methodDictionary
	| methodEditor |
	(methods isNil and: [self edRequiresRecompile not]) ifTrue: [^ self subject methodDictionary].
	methodEditor _ methods ifNil: [MethodDictionaryEditor on: self subject methodDictionary].
	^ methodEditor buildFor: self! !

!MetaclassEditor methodsFor: 'reflecting' stamp: 'cwp 11/5/2005 14:49'!
name
	^ editor name, ' class'! !

!MetaclassEditor methodsFor: 'metaclass' stamp: 'cwp 10/23/2005 14:43'!
new
	^ editor _ self basicNew! !

!MetaclassEditor methodsFor: 'printing' stamp: 'cwp 10/23/2005 14:45'!
printOn: aStream
	aStream
		nextPutAll: 'a MetaclassEditor on: ';
		print: editor subject ! !

!MetaclassEditor methodsFor: 'editing' stamp: 'cwp 10/27/2005 08:31'!
removeInstVarName: aString 
	instVarNames ifNil: [instVarNames _ self subject instVarNames].
	instVarNames _ instVarNames copyWithout: aString! !

!MetaclassEditor methodsFor: 'editing' stamp: 'cwp 10/28/2005 08:20'!
removeSelector: aSymbol 
	methods ifNil: [methods _ MethodDictionaryEditor on: self subject methodDictionary].
	methods remove: aSymbol.! !

!MetaclassEditor methodsFor: 'accessing' stamp: 'cwp 11/5/2005 14:42'!
subject
	^ editor subject ifNotNilDo: [:subject | subject class]! !

!MetaclassEditor methodsFor: 'reflecting' stamp: 'cwp 10/27/2005 08:35'!
superclass
	^ subjectSuperclass ifNil: [self subject superclass]! !

!MetaclassEditor methodsFor: 'editing' stamp: 'cwp 11/4/2005 21:23'!
superclass: aClass
	subjectSuperclass _ aClass! !

TestCase subclass: #ClassEditorTest
	instanceVariableNames: 'editor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemEditor-Tests'!

ClassEditorTest subclass: #ClassEditorBuildTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemEditor-Tests'!

!ClassEditorBuildTest methodsFor: 'tests' stamp: 'cwp 10/30/2005 16:13'!
test01NoChange
	"Since there was no change, we don't have to rebuild the class at all."

	self assert: editor edBuild == editor subject.
	self deny: editor edRequiresRecompile! !

!ClassEditorBuildTest methodsFor: 'tests' stamp: 'cwp 10/30/2005 16:26'!
test02AddInstVar
	
	| result |
	editor addInstVarName: 'gamma'.
	result _ editor edBuild.
	self deny: result == editor subject.
	self assert: result name = editor subject name.
	self assert: result instVarNames = editor instVarNames.
	self assert: result format = editor format.
! !

!ClassEditorBuildTest methodsFor: 'tests' stamp: 'cwp 10/30/2005 16:26'!
test03Superclass
	
	| result |
	editor superclass: self class.
	result _ editor edBuild.
	self deny: result == editor subject.
	self assert: result superclass == self class.! !

!ClassEditorBuildTest methodsFor: 'tests' stamp: 'cwp 10/30/2005 16:26'!
test04AddClassVar
	
	| result |
	editor addClassVarName: 'Gimel'.
	result _ editor edBuild.
	self deny: result == editor subject.
	self assert: result classVarNames = editor classVarNames.
! !

!ClassEditorBuildTest methodsFor: 'tests' stamp: 'cwp 10/30/2005 16:26'!
test05RemoveClassVar
	
	| result |
	editor removeClassVarName: 'Beth'.
	result _ editor edBuild.
	self deny: result == editor subject.
	self assert: result classVarNames = editor classVarNames.! !

!ClassEditorBuildTest methodsFor: 'tests' stamp: 'cwp 10/30/2005 16:26'!
test06PreserveClassVar
	
	| result object |
	object _ Object new.
	editor removeClassVarName: 'Beth'.
	editor subject aleph: object.
	result _ editor edBuild.
	self deny: result == editor subject.
	self assert: result aleph == object! !

!ClassEditorBuildTest methodsFor: 'tests' stamp: 'cwp 10/30/2005 16:26'!
test07AddSharedPool
	
	| result pool |
	pool _ Dictionary new.
	editor addSharedPool: pool.
	result _ editor edBuild.
	self deny: result == editor subject.
	self assert: (result sharedPools includes: pool).
	self deny: (editor subject sharedPools includes: pool).! !

!ClassEditorBuildTest methodsFor: 'tests' stamp: 'cwp 10/30/2005 16:26'!
test08RemoveSharedPool
	
	| result |
	editor removeSharedPool: EditorSubjectPool.
	result _ editor edBuild.
	self deny: result == editor subject.
	self deny: (result sharedPools includes: EditorSubjectPool).
	self assert: (editor subject sharedPools includes: EditorSubjectPool).! !

!ClassEditorBuildTest methodsFor: 'tests' stamp: 'cwp 11/5/2005 11:50'!
test09ExistingMethods
	
	| result |
	editor compile: 'waw ^ 3' classified: 'phoenician'.
	result _ editor edBuild.
	self assert: (result compiledMethodAt: #het) == (editor subject compiledMethodAt: #het)! !

!ClassEditorBuildTest methodsFor: 'tests' stamp: 'cwp 10/26/2005 22:25'!
test10MethodRemoved
	
	| dict |
	editor removeSelector: #het.
	dict _ editor methodDictionary.
	self assert: dict isEmpty! !

!ClassEditorBuildTest methodsFor: 'tests' stamp: 'cwp 10/30/2005 13:28'!
test11MethodAdded
	
	| dict |
	editor 
		compile: 'zayin ^ 2'
		classified: 'numbers'
		withStamp: 'cwp 5/30/2004 09:27'
		notifying: nil
		logSource: true.
	dict _ editor methodDictionary.
	self assert: editor edRequiresBuild.
	self assert: (dict at: #zayin) isCompiledMethod.
! !

!ClassEditorBuildTest methodsFor: 'tests' stamp: 'cwp 10/30/2005 17:07'!
test12MethodRecompilation
	
	| dict |
	editor addInstVarName: 'gamma'.
	dict _ editor methodDictionary.
	self deny: (dict at: #het) == (editor subject compiledMethodAt: #het).
! !

!ClassEditorBuildTest methodsFor: 'tests' stamp: 'cwp 11/5/2005 14:52'!
test13NoSubject
	
	| result |
	editor _ ClassEditor forNewClassNamed: #EditorSubject2.
	result _ editor edBuild.
	self assert: result name = #EditorSubject2! !

ClassEditorTest subclass: #ClassEditorOntologyTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemEditor-Tests'!

!ClassEditorOntologyTest methodsFor: 'tests' stamp: 'cwp 10/23/2005 15:06'!
test01Creation
	"This invariant allows editors and their subject classes to use
	exactly the same reflection protocol, so that the only modification
	required to allow tools to modify the system atomically is to send
	#commit when all modifications are complete."

	self assert: editor subject == EditorSubject.
	self assert: editor class subject == EditorSubject class! !

!ClassEditorOntologyTest methodsFor: 'tests' stamp: 'cwp 10/23/2005 15:06'!
test02Printing
	"This makes debugging easier."
	
	self assert: editor printString = 'a ClassEditor on: EditorSubject'.
	self assert: editor class printString = 'a MetaclassEditor on: EditorSubject'.! !

!ClassEditorOntologyTest methodsFor: 'tests' stamp: 'cwp 10/24/2005 07:47'!
test03ClassReferences

	"The instance is a strange beast. Its class is created on the fly, and is
	both an instance of MetaclassEditor and a subclass of ClassEditor. 
	See #testCreation." 
	self assert: editor class class == MetaclassEditor.
	self assert: (editor class instVarNamed: 'superclass') == ClassEditor.


	"editor is an instance of a light-weight class, so we don't register it
	with its superclass. In fact, the only thing that keeps it from being
	garbage collected is the class pointer from editor."
	self deny: (ClassEditor subclasses includes: editor class).

! !

!ClassEditorOntologyTest methodsFor: 'tests' stamp: 'cwp 10/23/2005 15:07'!
test04IsKindOfClass
	"A class and its editor are polymorphic, but this kind of
	explicit test can tell the difference."

	self deny: (editor class isKindOf: Class)! !

!ClassEditorOntologyTest methodsFor: 'tests' stamp: 'cwp 10/23/2005 15:24'!
test05ClassPool
	"To have DoIts be executed in the right context by a debugger or inspector,
	the generated class needs to be adoptable by FakeClassPool."

	self 
		shouldnt: [FakeClassPool adopt: editor class]
		raise: Error.! !

!ClassEditorOntologyTest methodsFor: 'tests' stamp: 'cwp 11/3/2005 23:30'!
test06Format
	"Despite having an instance variable called 'format' 
	MetaclassEditors should answer the format of the 
	subject's metaclass, not the format of ClassEditor class."

	self assert: editor class format = EditorSubject class format! !

!ClassEditorOntologyTest methodsFor: 'tests' stamp: 'cwp 10/24/2005 07:43'!
test07Superclass
	"Despite having an instance variable call 'superclass' 
	MetaclassEditors should answer the superclass of the 
	subject's class, not ClassEditor."

	self assert: editor class superclass = EditorSubject class superclass! !

ClassEditorTest subclass: #ClassEditorProtocolTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemEditor-Tests'!

!ClassEditorProtocolTest methodsFor: 'tests' stamp: 'cwp 10/23/2005 15:40'!
test01InstVarNames
	self assert: editor instVarNames = editor subject instVarNames! !

!ClassEditorProtocolTest methodsFor: 'tests' stamp: 'cwp 10/23/2005 15:36'!
test02AddInstVarName
	editor addInstVarName: 'gamma'.
	self assert: editor instVarNames = (editor subject instVarNames copyWith: 'gamma')! !

!ClassEditorProtocolTest methodsFor: 'tests' stamp: 'cwp 10/23/2005 15:58'!
test03RemoveClassVarName
	editor removeClassVarName: 'Beth'.
	self assert: editor classVarNames = (editor subject classVarNames copyWithout: 'Beth')! !

!ClassEditorProtocolTest methodsFor: 'tests' stamp: 'cwp 10/23/2005 15:40'!
test04ClassVarNames
	self assert: editor classVarNames = editor subject classVarNames! !

!ClassEditorProtocolTest methodsFor: 'tests' stamp: 'cwp 10/24/2005 08:23'!
test05AddClassVarName
	editor addClassVarName: #Gimel.
	self assert: editor classVarNames = (editor subject classVarNames copyWith: #Gimel)! !

!ClassEditorProtocolTest methodsFor: 'tests' stamp: 'cwp 10/23/2005 15:59'!
test06RemoveClassVarName
	editor removeClassVarName: 'Beth'.
	self assert: editor classVarNames = (editor subject classVarNames copyWithout: 'Beth')! !

!ClassEditorProtocolTest methodsFor: 'tests' stamp: 'cwp 10/23/2005 16:00'!
test07SharedPools
	self assert: editor sharedPools = editor subject sharedPools! !

!ClassEditorProtocolTest methodsFor: 'tests' stamp: 'cwp 10/23/2005 16:47'!
test08AddSharedPool
	| pool |
	pool _ Dictionary new.
	editor addSharedPool: pool.
	self assert: editor sharedPools = (editor subject sharedPools copyWith: pool)! !

!ClassEditorProtocolTest methodsFor: 'tests' stamp: 'cwp 10/24/2005 07:51'!
test09RemoveSharedPool
	editor removeSharedPool: EditorSubjectPool.
	self assert: editor sharedPools = (editor subject sharedPools copyWithout: EditorSubjectPool)! !

!ClassEditorProtocolTest methodsFor: 'tests' stamp: 'cwp 10/24/2005 07:53'!
test10Superclass
	editor superclass: self class.
	self assert: editor superclass == self class.! !

!ClassEditorProtocolTest methodsFor: 'tests' stamp: 'cwp 10/24/2005 08:27'!
test11ClassVarNamesInterned
	editor addClassVarName: 'Gimel'.
	self assert: (editor classVarNames anySatisfy: [:ea | ea == #Gimel])! !

!ClassEditorProtocolTest methodsFor: 'tests' stamp: 'cwp 10/26/2005 08:40'!
test12AddSelector
	self deny: (editor includesSelector: #zayin).
	editor 
		compile: 'zayin ^ 1'
		classified: 'numbers'
		withStamp: 'cwp 5/30/2004 09:27'
		notifying: nil
		logSource: true.
	self assert: (editor includesSelector: #zayin)! !

!ClassEditorProtocolTest methodsFor: 'tests' stamp: 'cwp 10/28/2005 08:13'!
test13RemoveSelector
	editor removeSelector: #het.
	self deny: (editor includesSelector: #het)! !

!ClassEditorProtocolTest methodsFor: 'tests' stamp: 'cwp 10/26/2005 08:40'!
test14AddAndRemoveSelector
	editor 
		compile: 'zayin ^ 1'
		classified: 'numbers'
		withStamp: 'cwp 5/30/2004 09:27'
		notifying: nil
		logSource: true.
	editor removeSelector: #zayin.
	self deny: (editor includesSelector: #zayin).
	! !

!ClassEditorProtocolTest methodsFor: 'tests' stamp: 'cwp 10/28/2005 08:16'!
test15RemoveNewSelector
	editor removeSelector: #zayin.
	self deny: (editor includesSelector: #zayin)! !

!ClassEditorProtocolTest methodsFor: 'tests' stamp: 'cwp 10/28/2005 22:06'!
test16TypeOfClass
	editor typeOfClass = #normal! !

!ClassEditorProtocolTest methodsFor: 'tests' stamp: 'cwp 10/29/2005 10:20'!
test17Format
	| superFormat editorFormat |
	superFormat _ ClassFormat fromBits: EditorSubject superclass format.
	editorFormat _ superFormat namedSubclass: editor instVarNames size.
	self assert: editor format = editorFormat bits! !

!ClassEditorProtocolTest methodsFor: 'tests' stamp: 'cwp 10/29/2005 10:29'!
test18NewFormat
	| superFormat editorFormat |
	editor typeOfClass: #variable.
	superFormat _ ClassFormat fromBits: EditorSubject superclass format.
	editorFormat _ superFormat indexedSubclass: editor instVarNames size.
	self assert: editor format = editorFormat bits! !

!ClassEditorProtocolTest methodsFor: 'tests' stamp: 'cwp 10/29/2005 10:27'!
test19BeBytes
	editor typeOfClass: #bytes.
	self assert: editor typeOfClass == #bytes.
	self assert: editor isBytes.
	self assert: editor isBits.
	self assert: editor isVariable.
	self deny: editor isPointers.! !

!ClassEditorProtocolTest methodsFor: 'tests' stamp: 'cwp 10/29/2005 10:28'!
test20BeWords
	editor typeOfClass: #words.
	self assert: editor typeOfClass == #words.
	self assert: editor isWords.
	self assert: editor isBits.
	self assert: editor isVariable.
	self deny: editor isPointers.! !

!ClassEditorProtocolTest methodsFor: 'tests' stamp: 'cwp 10/29/2005 10:33'!
test21BeWeak
	editor typeOfClass: #weak.
	self assert: editor typeOfClass == #weak.
	self assert: editor isWords.
	self assert: editor isVariable.
	self assert: editor isPointers.
	self deny: editor isBits.
! !

!ClassEditorProtocolTest methodsFor: 'tests' stamp: 'cwp 10/29/2005 10:34'!
test22BeVariable
	editor typeOfClass: #variable.
	self assert: editor typeOfClass == #variable.
	self assert: editor isWords.
	self assert: editor isVariable.
	self assert: editor isPointers.
	self deny: editor isWeak.
	self deny: editor isBits.
! !

!ClassEditorProtocolTest methodsFor: 'tests' stamp: 'cwp 10/29/2005 10:35'!
test23BeNormal
	editor typeOfClass: #normal.
	self assert: editor typeOfClass == #normal.
	self assert: editor isPointers.
	self deny: editor isWords.
	self deny: editor isVariable.
	self deny: editor isWeak.
	self deny: editor isBits.
! !

!ClassEditorProtocolTest methodsFor: 'tests' stamp: 'cwp 10/29/2005 23:01'!
test24CompileClassifiedWithStampNotifying
	self deny: (editor includesSelector: #zayin).
	editor 
		compile: 'zayin ^ 1'
		classified: 'numbers'
		withStamp: 'cwp 5/30/2004 09:27'
		notifying: nil.
	self assert: (editor includesSelector: #zayin)! !

!ClassEditorProtocolTest methodsFor: 'tests' stamp: 'cwp 10/29/2005 23:04'!
test25CompileClassifiedNotifying
	self deny: (editor includesSelector: #zayin).
	editor 
		compile: 'zayin ^ 1'
		classified: 'numbers'
		notifying: nil.
	self assert: (editor includesSelector: #zayin)! !

!ClassEditorProtocolTest methodsFor: 'tests' stamp: 'cwp 10/30/2005 10:01'!
test26CompileClassified
	self deny: (editor includesSelector: #zayin).
	editor 
		compile: 'zayin ^ 1'
		classified: 'numbers'.
	self assert: (editor includesSelector: #zayin)! !

!ClassEditorProtocolTest methodsFor: 'tests' stamp: 'cwp 11/3/2005 07:46'!
test27Subclass
	| sub |
	sub _ editor
			subclass: #EditorSubjectSubclass
			instanceVariableNames: ''
			classVariableNames: ''
			poolDictionaries: ''
			category: 'SystemEditor-Tests'.
	self assert: sub subject isNil.
	self assert: sub name = #EditorSubjectSubclass.
	self assert: sub instVarNames isEmpty.
	self assert: sub classVarNames isEmpty.
	self assert: sub sharedPools isEmpty.! !

!ClassEditorProtocolTest methodsFor: 'tests' stamp: 'cwp 11/12/2005 21:00'!
test28InstSize
	| sub |
	sub _ editor
			subclass: #EditorSubjectSubclass
			instanceVariableNames: 'gamma'
			classVariableNames: ''
			poolDictionaries: ''
			category: 'SystemEditor-Tests'.
	self assert: sub instSize = 3! !

!ClassEditorProtocolTest methodsFor: 'tests' stamp: 'cwp 11/12/2005 21:35'!
test29InstVarsArentDuplicated
	editor addInstVarName: 'gamma'.
	editor addInstVarName: 'gamma'.
	self assert: editor instVarNames = (editor subject instVarNames copyWith: 'gamma')! !

!ClassEditorProtocolTest methodsFor: 'tests' stamp: 'cwp 11/12/2005 21:39'!
test30ClassVarsArentDuplicated
	editor addClassVarName: 'Gimel'.
	editor addClassVarName: 'Gimel'.
	self assert: editor classVarNames = (editor subject classVarNames copyWith: 'Gimel')! !

!ClassEditorTest class methodsFor: 'testing' stamp: 'cwp 11/10/2005 08:14'!
isAbstract
	^ self name == #ClassEditorTest! !

!ClassEditorTest methodsFor: 'running' stamp: 'cwp 10/23/2005 15:29'!
setUp
	editor := ClassEditor on: EditorSubject! !

ClassEditorTest subclass: #ClassEditorValidationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemEditor-Tests'!

!ClassEditorValidationTest methodsFor: 'tests' stamp: 'cwp 11/12/2005 21:58'!
test01NoChangeIsValid
	self assert: editor edIsValid ! !

!ClassEditorValidationTest methodsFor: 'tests' stamp: 'cwp 11/12/2005 21:58'!
test02BitsWithVariablesIsInvalid
	editor typeOfClass: #bytes.
	self deny: editor edIsValid ! !

!ClassEditorValidationTest methodsFor: 'tests' stamp: 'cwp 11/12/2005 21:58'!
test03SameTypeIsValid
	editor addInstVarName: 'gamma'.
	self assert: editor edIsValid ! !

!ClassEditorValidationTest methodsFor: 'tests' stamp: 'cwp 11/12/2005 21:58'!
test04TooManyInstVars
	1 to: 255 do: [:i | editor addInstVarName: i asString].
	self deny: editor edIsValid! !

TestCase subclass: #ClassFormatTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemEditor-Tests'!

!ClassFormatTest methodsFor: 'tests' stamp: 'cwp 10/23/2005 18:27'!
testBitsWithInstSize
	| format |
	format _ ClassFormat bytes.
	self should: [format withInstSize: 2] raise: Error! !

!ClassFormatTest methodsFor: 'tests' stamp: 'cwp 10/23/2005 18:28'!
testBytes
	| format |
	format := ClassFormat bytes.
	self assert: format instSize = 0.
	self assert: format isVariable.
	self assert: format isBits.
	self assert: format isBytes.
	self deny: format isFixed.
	self deny: format isPointers.
	self deny: format isWords.
	self deny: format isWeak
! !

!ClassFormatTest methodsFor: 'tests' stamp: 'cwp 10/23/2005 18:27'!
testIndexed
	| format |
	format := ClassFormat indexed.
	self assert: format instSize = 0.
	self assert: format isPointers.
	self assert: format isWords.
	self assert: format isVariable.
	self deny: format isFixed.
	self deny: format isBits.
	self deny: format isBytes.
	self deny: format isWeak
! !

!ClassFormatTest methodsFor: 'tests' stamp: 'cwp 10/23/2005 18:28'!
testIndexedSubclass
	| superFormat subFormat |
	superFormat := ClassFormat named: 3.
	subFormat := superFormat indexedSubclass: 2.
	self assert: superFormat instSize = 3.
	self assert: subFormat instSize = 5.
	self assert: subFormat isVariable.
	self assert: subFormat isPointers.
	self assert: subFormat isWords.
	self deny: subFormat isFixed.
	self deny: subFormat isBits.
	self deny: subFormat isBytes.
	self deny: subFormat isWeak! !

!ClassFormatTest methodsFor: 'tests' stamp: 'cwp 10/23/2005 18:28'!
testIndexedWithInstSize
	| old new |
	old _ ClassFormat indexed: 3.
	new _ old withInstSize: 5.
	self assert: new instSize = 5.
	self assert: new instSpec = old instSpec.
	self assert: new cClassIndex = old cClassIndex! !

!ClassFormatTest methodsFor: 'tests' stamp: 'cwp 10/23/2005 18:27'!
testNamed
	| format |
	format := ClassFormat named: 3.
	self assert: format instSize = 3.
	self assert: format isFixed.
	self assert: format isPointers.
	self assert: format isWords.
	self deny: format isVariable.
	self deny: format isBits.
	self deny: format isBytes.
	self deny: format isWeak! !

!ClassFormatTest methodsFor: 'tests' stamp: 'cwp 10/23/2005 18:28'!
testNamedAndIndexed
	| format |
	format := ClassFormat indexed: 3.
	self assert: format instSize = 3.
	self assert: format isPointers.
	self assert: format isWords.
	self assert: format isVariable.
	self deny: format isFixed.
	self deny: format isBits.
	self deny: format isBytes.
	self deny: format isWeak
! !

!ClassFormatTest methodsFor: 'tests' stamp: 'cwp 10/23/2005 18:28'!
testNamedSubclass
	| superFormat subFormat |
	superFormat := ClassFormat named: 3.
	subFormat := superFormat namedSubclass: 2.
	self assert: superFormat instSize = 3.
	self assert: subFormat instSize = 5.
	self assert: subFormat isFixed.
	self assert: subFormat isPointers.
	self assert: subFormat isWords.
	self deny: subFormat isVariable.
	self deny: subFormat isBits.
	self deny: subFormat isBytes.
	self deny: subFormat isWeak! !

!ClassFormatTest methodsFor: 'tests' stamp: 'cwp 10/23/2005 18:28'!
testNamedWithInstSize
	| old new |
	old _ ClassFormat named: 3.
	new _ old withInstSize: 5.
	self assert: new instSize = 5.
	self assert: new instSpec = old instSpec.
	self assert: new cClassIndex = old cClassIndex! !

!ClassFormatTest methodsFor: 'tests' stamp: 'cwp 10/23/2005 18:28'!
testNoState
	| format |
	format := ClassFormat noState.
	self assert: format instSize = 0.
	self assert: format isFixed.
	self assert: format isPointers.
	self assert: format isWords.
	self deny: format isVariable.
	self deny: format isBits.
	self deny: format isBytes.
	self deny: format isWeak! !

!ClassFormatTest methodsFor: 'tests' stamp: 'cwp 10/23/2005 18:28'!
testWeak
	| format |
	format := ClassFormat weak.
	self assert: format instSize = 0.
	self assert: format isVariable.
	self assert: format isPointers.
	self assert: format isWords.
	self assert: format isWeak.
	self deny: format isFixed.
	self deny: format isBits.
	self deny: format isBytes.
! !

!ClassFormatTest methodsFor: 'tests' stamp: 'cwp 10/23/2005 18:28'!
testWords
	| format |
	format := ClassFormat words.
	self assert: format instSize = 0.
	self assert: format isVariable.
	self assert: format isBits.
	self assert: format isWords.
	self deny: format isFixed.
	self deny: format isPointers.
	self deny: format isBytes.
	self deny: format isWeak
! !

TestCase subclass: #EditorSubjectSubTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemEditor-Tests'!

EditorSubjectSubTest subclass: #ClassExporterTest
	instanceVariableNames: 'exporter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemEditor-Tests'!

!ClassExporterTest methodsFor: 'running' stamp: 'cwp 11/10/2005 08:08'!
setUp
	super setUp.
	exporter _ ClassExporter on: Smalltalk.
! !

!ClassExporterTest methodsFor: 'tests' stamp: 'cwp 11/5/2005 17:21'!
test01ClassIsAddedToEnvironment
	| class |
	class _ self createClass.
	exporter addClass: class.
	exporter commit.
	self assert: (Smalltalk at: class name) == class
	! !

!ClassExporterTest methodsFor: 'tests' stamp: 'cwp 11/5/2005 17:30'!
test02ClassIsAddedToSuperclass
	| class |
	class _ self createClass.
	exporter addClass: class.
	exporter commit.
	self assert: (class superclass subclasses includes: class)
	! !

!ClassExporterTest methodsFor: 'tests' stamp: 'cwp 11/5/2005 17:40'!
test03ExistingReferencesAreMaintained
	| class reference |
	reference _ Smalltalk at: #EditorSubjectSub.
	class _ self createClassNamed: #EditorSubjectSub.
	exporter addClass: class.
	exporter commit.
	self assert: (Smalltalk at: #EditorSubjectSub) == reference.! !

!ClassExporterTest methodsFor: 'tests' stamp: 'cwp 11/5/2005 18:43'!
test04ClassKnowsItsEnvironment
	| class |
	class _ self createClass.
	exporter addClass: class.
	exporter commit.
	self assert: class environment == exporter environment
	! !

!ClassExporterTest methodsFor: 'tests' stamp: 'cwp 11/7/2005 20:24'!
test05NewClassReplacesOld
	| class |
	class _ self createClassNamed: #EditorSubjectSub.
	exporter addClass: class.
	exporter commit.
	self assert: ((Smalltalk at: #EditorSubjectSub) instVarNames includes: 'alpha')! !

!EditorSubjectSubTest class methodsFor: 'as yet unclassified' stamp: 'cwp 11/10/2005 08:12'!
isAbstract
	^ self name == #EditorSubjectSubTest! !

!EditorSubjectSubTest methodsFor: 'support' stamp: 'cwp 11/10/2005 08:09'!
createClass
	^ self createClassNamed: #EditorSubjectSub2! !

!EditorSubjectSubTest methodsFor: 'support' stamp: 'cwp 11/10/2005 08:09'!
createClassNamed: aSymbol 
	| classEditor |
	classEditor := (ClassEditor on: EditorSubject) 
				subclass: aSymbol
				instanceVariableNames: 'alpha'
				classVariableNames: ''
				poolDictionaries: ''
				category: 'SystemEditor-Tests'.
	^classEditor edBuild! !

!EditorSubjectSubTest methodsFor: 'running' stamp: 'cwp 11/10/2005 08:21'!
setUp
	(Smalltalk at: #EditorSubject)
		subclass: #EditorSubjectSub
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: 'SystemEditor-Tests'! !

!EditorSubjectSubTest methodsFor: 'running' stamp: 'cwp 11/10/2005 08:21'!
tearDown
	(Smalltalk at: #EditorSubject)
		allSubclasses do: [:ea | ea removeFromSystem]! !

EditorSubjectSubTest subclass: #SystemEditorCommitTest
	instanceVariableNames: 'editor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemEditor-Tests'!

!SystemEditorCommitTest methodsFor: 'running' stamp: 'cwp 11/10/2005 08:11'!
setUp
	super setUp.
	editor _ SystemEditor new.
! !

!SystemEditorCommitTest methodsFor: 'tests' stamp: 'cwp 11/10/2005 08:15'!
test01MigratesInstances
	| inst classEditor class |
	class _ editor subject at: #EditorSubjectSub.
	inst := class new.
	classEditor := editor at: #EditorSubjectSub.
	classEditor addInstVarName: 'gamma'.
	editor commit.
	self assert: (inst class instVarNames includes: 'gamma')! !

TestCase subclass: #InstanceMigratorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemEditor-Tests'!

!InstanceMigratorTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/10/2005 07:45'!
createClassPair
	| editor oldClass newClass |
	editor := ClassEditor on: EditorSubject.
	editor compile: 'isInstanceOfNewClass ^ false' classified: 'testing'.
	oldClass := editor edBuild.
	editor compile: 'isInstanceOfNewClass ^ true' classified: 'testing'.
	newClass := editor edBuild.
	^ oldClass -> newClass! !

!InstanceMigratorTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/2/2005 20:06'!
testOneClassTransaction
	| mutator classes inst |
	classes _ self createClassPair.
	inst _ classes key new.
	mutator := MigrationTransaction new.
	mutator addMigrator: (InstanceMigrator from: classes key to: classes value).
	mutator commit.
	self assert: inst isInstanceOfNewClass! !

!InstanceMigratorTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/2/2005 20:06'!
testTwoClassTransaction
	| mutator classes inst1 inst2 |
	mutator := MigrationTransaction new.

	classes _ self createClassPair.
	inst1 _ classes key new.
	mutator addMigrator: (InstanceMigrator from: classes key to: classes value).

	classes _ self createClassPair.
	inst2 _ classes key new.
	mutator addMigrator: (InstanceMigrator from: classes key to: classes value).

	mutator commit.
	self assert: inst1 isInstanceOfNewClass.
	self assert: inst2 isInstanceOfNewClass! !

TestCase subclass: #MetaclassEditorTest
	instanceVariableNames: 'editor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemEditor-Tests'!

MetaclassEditorTest subclass: #MetaclassEditorBuildTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemEditor-Tests'!

!MetaclassEditorBuildTest methodsFor: 'tests' stamp: 'cwp 11/5/2005 14:30'!
test01NoChange
	"We always rebuild the metaclass, since the class needs to be an instance of it."

	self deny: editor edBuild == editor subject.
	self deny: editor edRequiresRecompile! !

!MetaclassEditorBuildTest methodsFor: 'tests' stamp: 'cwp 11/4/2005 22:05'!
test02AddInstVar
	
	| result |
	editor addInstVarName: 'gamma'.
	result _ editor edBuild.
	self deny: result == editor subject.
	self assert: result instVarNames = editor instVarNames.
	self assert: result format = editor format.
! !

!MetaclassEditorBuildTest methodsFor: 'tests' stamp: 'cwp 11/4/2005 22:06'!
test03Superclass
	
	| result |
	editor superclass: self class.
	result _ editor edBuild.
	self deny: result == editor subject.
	self assert: result superclass == self class.! !

!MetaclassEditorBuildTest methodsFor: 'tests' stamp: 'cwp 11/5/2005 11:46'!
test04ExistingMethods
	
	| result |
	editor compile: 'pe ^ 2'.
	result _ editor edBuild.
	self assert: (result compiledMethodAt: #ayin) == (editor subject compiledMethodAt: #ayin)! !

!MetaclassEditorBuildTest methodsFor: 'tests' stamp: 'cwp 11/5/2005 11:39'!
test05MethodRemoved
	
	| dict |
	editor removeSelector: #ayin.
	dict _ editor methodDictionary.
	self deny: (dict includesKey: #ayin)! !

!MetaclassEditorBuildTest methodsFor: 'tests' stamp: 'cwp 11/5/2005 11:41'!
test06MethodAdded
	
	| dict |
	editor 
		compile: 'pe ^ -2'
		classified: 'letters'
		withStamp: 'cwp 5/30/2004 09:27'
		notifying: nil
		logSource: true.
	dict _ editor methodDictionary.
	self assert: (dict at: #pe) isCompiledMethod.
! !

!MetaclassEditorBuildTest methodsFor: 'tests' stamp: 'cwp 11/5/2005 11:41'!
test07MethodRecompilation
	
	| dict |
	editor addInstVarName: 'psi'.
	dict _ editor methodDictionary.
	self deny: (dict at: #ayin) == (editor subject compiledMethodAt: #ayin).
! !

!MetaclassEditorBuildTest methodsFor: 'tests' stamp: 'cwp 11/5/2005 14:50'!
test09NoSubject
	
	| result |
	editor _ (ClassEditor forNewClassNamed: #EditorSubect2) class.
	result _ editor edBuild.
	self assert: result isMeta! !

MetaclassEditorTest subclass: #MetaclassEditorProtocolTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemEditor-Tests'!

!MetaclassEditorProtocolTest methodsFor: 'tests' stamp: 'cwp 10/23/2005 22:50'!
test01InstVarNames
	self assert: editor instVarNames = editor subject instVarNames! !

!MetaclassEditorProtocolTest methodsFor: 'tests' stamp: 'cwp 10/23/2005 23:14'!
test02AddInstVarName
	editor addInstVarName: 'psi'.
	self assert: editor instVarNames = (editor subject instVarNames copyWith: 'psi')! !

!MetaclassEditorProtocolTest methodsFor: 'tests' stamp: 'cwp 10/27/2005 08:31'!
test03RemoveInstVarName
	editor removeInstVarName: 'omega'.
	self assert: editor instVarNames = (editor subject instVarNames copyWithout: 'omega')! !

!MetaclassEditorProtocolTest methodsFor: 'tests' stamp: 'cwp 11/4/2005 21:13'!
test04Superclass
	
	| result |
	editor superclass: self class.
	result _ editor edBuild.
	self deny: result == editor subject.
	self assert: result superclass == self class.! !

!MetaclassEditorProtocolTest methodsFor: 'tests' stamp: 'cwp 10/28/2005 08:09'!
test5AddSelector
	self deny: (editor includesSelector: #zayin).
	editor 
		compile: 'zayin ^ 1'
		classified: 'numbers'
		withStamp: 'cwp 5/30/2004 09:27'
		notifying: nil
		logSource: true.
	self assert: (editor includesSelector: #zayin)! !

!MetaclassEditorProtocolTest methodsFor: 'tests' stamp: 'cwp 10/28/2005 08:19'!
test6RemoveNewSelector
	editor removeSelector: #pe.
	self deny: (editor includesSelector: #pe)! !

!MetaclassEditorProtocolTest methodsFor: 'tests' stamp: 'cwp 10/28/2005 08:19'!
test7RemoveSelector
	editor removeSelector: #ayin.
	self deny: (editor includesSelector: #ayin)! !

!MetaclassEditorProtocolTest methodsFor: 'tests' stamp: 'cwp 10/28/2005 08:23'!
test8AddAndRemoveSelector
	editor 
		compile: 'pe ^ 1'
		classified: 'phoenician'
		withStamp: 'cwp 5/30/2004 09:27'
		notifying: nil
		logSource: true.
	editor removeSelector: #pe.
	self deny: (editor includesSelector: #pe).
	! !

!MetaclassEditorTest class methodsFor: 'as yet unclassified' stamp: 'cwp 11/10/2005 08:15'!
isAbstract
	^ self name == #MetaclassEditorTest! !

!MetaclassEditorTest methodsFor: 'running' stamp: 'cwp 10/24/2005 07:57'!
setUp
	editor _ (ClassEditor on: EditorSubject) class! !

TestCase subclass: #SystemEditorTest
	instanceVariableNames: 'editor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemEditor-Tests'!

!SystemEditorTest methodsFor: 'running' stamp: 'cwp 10/28/2005 20:41'!
setUp
	editor _ SystemEditor new.
! !

!SystemEditorTest methodsFor: 'testing' stamp: 'cwp 11/6/2005 00:21'!
test01SubjectCanBeSpecified
	editor _ SystemEditor on: Smalltalk.
	self assert: editor subject == Smalltalk! !

!SystemEditorTest methodsFor: 'testing' stamp: 'cwp 11/6/2005 00:21'!
test02DefaultSubjectIsSmalltalk
	self assert: editor subject == Smalltalk! !

!SystemEditorTest methodsFor: 'testing' stamp: 'cwp 11/6/2005 00:21'!
test03AtCreatesClassEditor
	| classEditor |
	classEditor _ editor at: #EditorSubject.
	self assert: classEditor subject = EditorSubject! !

!SystemEditorTest methodsFor: 'testing' stamp: 'cwp 11/6/2005 00:22'!
test04ClassEditorsAreCached
	| first second |
	first _ editor at: #EditorSubject.
	second _ editor at: #EditorSubject.
	self assert: first == second! !

!SystemEditorTest methodsFor: 'testing' stamp: 'cwp 11/6/2005 00:22'!
test05ClassEditorsKnowTheirSystemEditors
	| first |
	first _ editor at: #EditorSubject.
	self assert: first system == editor! !

!SystemEditorTest methodsFor: 'testing' stamp: 'cwp 11/6/2005 23:12'!
test06AtCreatesEditorForNewClass
	| classEditor |
	classEditor _ editor at: #EditorSubject2.
	self assert: classEditor subject isNil.
	self assert: classEditor name = #EditorSubject2! !

!SystemEditorTest methodsFor: 'testing' stamp: 'cwp 11/7/2005 19:55'!
test07ReshapesSubclasses
	| superclass classes |
	superclass _ editor at: #ClassEditorTest.
	superclass addClassVarName: 'Gimmel'.
	editor edBuildClasses.
	classes _ editor instVarNamed: 'classes'.
	ClassEditorTest subclasses 
		do: [:old | self assert: (classes anySatisfy: 
				[:new | old name = new name])]! !

!SystemEditorTest methodsFor: 'testing' stamp: 'cwp 11/7/2005 19:43'!
test08DoesntRebuildSubclassesUnnecessarily
	| superclass classes |
	superclass _ editor at: #ClassEditorTest.
	superclass compile: 'het ^ #one' classified: 'testing'.
	editor edBuildClasses.
	classes _ editor instVarNamed: 'classes'.
	self assert: classes size = 1! !

!SystemEditorTest methodsFor: 'testing' stamp: 'cwp 11/7/2005 20:00'!
test09RecompilesSubclasses
	| superclass classes |
	superclass _ editor at: #ClassEditorTest.
	superclass addClassVarName: 'Gimmel'.
	editor edBuildClasses.
	classes _ editor instVarNamed: 'classes'.
	ClassEditorTest subclasses 
		do: [:old | self assert: (classes anySatisfy: 
				[:new | old name = new name])]! !

!SystemEditorTest methodsFor: 'testing' stamp: 'cwp 11/12/2005 20:45'!
test10ValidatesBeforeCommitting
	| classEditor |
	classEditor _ editor at: #EditorSubject.
	classEditor typeOfClass: #bytes.
	classEditor addInstVarName: 'test'.
	self 
		should: [editor commit]
		raise: InvalidClassFormat! !
